/*
	elementals.js (c) Jason M. Knight
	Version 2.1 BETA 1, 19 March 2017
*/

var
	_d = document,
	_w = window,
	_;

_d.head || (_d.head = _d.getElementsByTagName('head')[0]);

(function() {

	"use strict";

	function browserFix(e, n, t) {
		if (e[n]) return true;
		t || (t = n.charAt(0).toUpperCase() + n.substr(1));
		for (var i = 0, j, k; j = browserPrefixes[i]; i++)
			if (e[k = j + t]) return e[n] = e[k], true;
		return false;
	}

	function newAX(a) {
		try { return new activeXObject(a); } catch (e) { return false; }
	}

	function ptAdd(e, p) {
		for (var i in p) e.prototype[i] || (e.prototype[i] = p[i]);
	}

	function eXMLHttp(h, x) {

		if (!(x = this.result = window.XMLHttpRequest ? new XMLHttpRequest() : (
			newAX(mx2 + '.6.0') ||
			newAX(mx2 + '.3.0') ||
			newAX('Microsoft.' + mx)
		))) throw new Error('Unable to create XMLHttpRequest or ActiveX ' + mx);

		if (h.progress) x.onprogress = h.progress;

		x.getJSON = function() {
			return JSON.parse(this.responseText);
		};

		x.getXMLValueById = function(i) {
			return (i = this.responseXML.getElementById(i)) ? _.node.text(i) : null;
		};

		x.getXMLValuesByTagName = function(t, l, e) {
			if (!(e = this.responseXML.getElementsByTagName(t))) return false;
			if (l === true) return _.node.text(e[0]);
			if (!l || e.length < l) l = e.length;
			for (var r = [], i = 0; i < l; i++) r.push(_.node.text(e[i]));
			return r;
		};

		x.onreadystatechange  = function() {
			if (h.state && h.state[x.readyState]) return h.state[x.readyState](x, h);
			if (4 == x.readyState) {
				if (h.status) {
					if (h.status[x.status]) return h.status[x.status](x, h);
					if (h.status.catchAll) return h.status.catchAll(x, h);
				}
				_.log('Unhandled AJAX Status ' + x.status, h.onStatusLog);
			} else _.log('Unhandled AJAX readyState ' + x.readyState, h.onReadyLog);
		};

		if (h.request) {
			x.open(h.request[0], h.request[1]);
			if (h.mimeType) x.overrideMimeType(h.mimeType);
			if (h.headers) for (var i in h.headers)
				x.setRequestHeader(i, h.headers[i]);
			x.send(h.request[2]);
		}

	}
	
	function nCountBy(e, m, n) {
		var c = 0;
		_.node[n](e, function() { return c++ }, m);
		return c;
	}

	function escFunc(m) {
		return escMap[m] || '\\u' + (m.charCodeAt(0) + 65536).toString(16).substr(1);
	}

	function EventIE(e, v, c) {
		e.attachEvent('on' + v, function(n) {
			n || (n = window.event);
			n.target || (n.target = n.srcElement);
			n.currentTarget || (n.currentTarget = e);
			c(n);
		});
	}
	
	// CANNOT use data.set or data.get on clone nodes!

	function originalSort(a, b) {
		return _.compare.numeric(
			a.tag.getAttribute(d_op),
			b.tag.getAttribute(d_op)
		);
	}

	function uSortTBODYe(e) {
		return tList2.push(_.node.text(e)), true;
	}

	function uSortOp(e) {
		e.getAttribute(d_op) || e.setAttribute(d_op, tList1.length);
	}

	function uSortTBODYRow(e) {
		uSortOp(e);
		tList2 = [];
		_.node.eachChild(e, uSortTBODYe);
		tList1.push({ tag : e.cloneNode(true), data : tList2 });
		return tList2 = [], true;
	}

	function uSortLi(e) {
		uSortOp(e);
		tList1.push({ tag : e.cloneNode(true), data : _.node.text(e) });
		return true;
	}

	var
		browserPrefixes = ['ms','moz','webkit','moz'],
		escMap = {
			'"' : '\\"', '\\' : '\\\\', '\b' : '\\b', '\f' : '\\f',
			'\n' : '\\n', '\r' : '\\r', '\t' : '\\t'
		},
		escRegex = /[\\\u0000-\u001F\u0022\u2028\u2029]/g,
		stripCamelRegex = /([A-Z])/g,
		toCamelRegex = /(\W[\w])/g,
		trimRegex = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,

		nodePlaces = [ 'before', 'after', 'first', 'last', 'replace' ],

		d_op = 'data-uSortOriginalPlace',
		d_sort = 'uSortElementSorted',
		d_sel = 'eNodeSelectTarget',
		raf = 'requestAnimationFrame',
		caf = 'cancelAnimationFrame',
		mx = 'XMLHTTP',
		mx2 = 'Msxml2.' + mx,

		tList1 = [],
		tList2 = [],
		lastAnimTime = 0,

		msgLog = {

			alert : function(m) { alert(m) },

			append : function(m) {
				_.make('br', { last : _d.body });
				_.node.add(_d.body, m);
			},

			error : function(m) { throw new Error(m); },

			log : function(m) { if (_w.console) console.log(m); else this.append(m); },

			warn : function(m) { if (_w.console) console.warn(m); else this.append(m); }

		};

	_ = {

		ajax : function(h) {
			switch (typeof h) {
				case 'object': break;
				case 'function':
					h = { 'status' : { '200' : h } };
					break;
				default:
					throw new Error(
						'Invalid Ajax declaration, parameter "handler" not a function or object!'
					);
			}
			return (new eXMLHttp(h)).result;
		},

		class : {

			add : function(e, n) {
				if (n instanceof Array) return n.callbackOr(e, _.class.add);
				return _.class.exists(e, n) || (e.className += (e.className ? ' ' : '') + n);
			},

			exists : function(e, n) {
				if (n instanceof Array) return n.callbackAnd(e, _.class.exists);
				return RegExp('(\\s|^)' + n + '(\\s|$)').test(e.className);
			},

			remove : function(e, n) {
				if (n instanceof Array) return n.callbackOr(e, _.class.remove);
				if (!_.class.exists(e, n)) return false;
				e.className = e.className.replace(
					new RegExp("(\\s|^)" + n + "(\\s|$)")," "
				).trim();
				return true;
			},

			swap : function(e, o, n) {
				o = _.class.remove(e, o);
				n = _.class.add(e, n);
				return o || n;
			},

			toggle : function(e, n) {
				if (_.class.remove(e, n)) return false;
				_.class.add(e,n);
				return true;
			}

		}, // _.class

		compare : {

			string : function(a, b) {
				return _.string.normalize(a).localeCompare(
					_.string.normalize(b)
				);
			},

			stringI : function(a, b) {
				return _.string.normalize(a, true).localeCompare(
					_.string.normalize(b, true)
				);
			},

			numeric : function(a, b) {
				return (Number(a) || 0) - (Number(b) || 0);
			},

		}, // _.compare

		cookies : {

			defaults : {

				time : 34160760000000, // 'forever', 6 June 3052
				path : false,
				domain : false,
				secure : false

			},

			delete : function(n, p, d) {
				if (_.cookies.get(n)) cookie.set(n, '', 0, p, d);
			},

			get : function(n) {
				return n && (_d.cookie.match(
					new RegExp('(^|;)\\s*' + n + '\\s*=\\s*([^;]*)')
				) ? unescape(name[2]) : false);
			},

			set : function(n, v, t, p, d, s) {
				if (isInteger(t)) t = new Date(t);
				if (typeof t == 'Date') t = t.toGMTString();
				if (!t && _.cookies.defaults.time) t = _.cookies.defaults.time;
				if (!p && _.cookies.defaults.path) p = _.cookies.defaults.path;
				if (!d && _.cookies.defaults.domain) d = _.cookies.defaults.domain;
				if (s == undefined && _.cookies.defaults.secure) s = true;
				document.cookie = n + '=' + escape(v) +
					(t ? '; expires=' + t : '') +
					(p ? '; path=' + p : '') +
					(d ? '; domain=' + d : '') +
					(s ? '; secure' : '');
			},

			setAfter : function(n, v, t, p, d, s) {
				_.cookies.set(n, v, new Date().getTime() + t, p, d, s);
			}

		}, // _.cookie

		data : {

			get : function(e, n, s, r) {
				return (r = e.getAttribute(n = 'data-' + n)) === null ? false : 
					r === '' ? e.hasAttribute && e.hasAttribute(n) : 
						s ? r.split(',') : r;
			},
			
			set : function (e, n, v) {
				e['data-' + n] = v;
			}

		}, // _.data

		event : {

			add : function(e, v, c) { e.addEventListener(v, c, false); },

			prevent : function(e) {
				// this MAY be overkill... Oh, who are we kidding, it is!
				e.cancelBubble = true;
				if (e.stopPropagation) e.stopPropagation();
				if (e.preventDefault) e.preventDefault();
				e.returnValue = false;
			}

		}, // _.event

		form : {

			serialize : function(form) {
				// to-do throw if form is not <form>
				function add(n, v) {
					if (v && (v != '')) r +=
						(r ? '&' : '') +
						encodeURIComponent(n) +
						'=' +
						encodeURIComponent(v);
				}
				for (var i = 0, r = '', e, o; e = form.elements[i]; i++) {
					if (e.name) switch (e.tagName) {
						case 'INPUT':
							switch (e.type) {
								case 'file' :
									// to-do, add serialization for browsers that support it
									throw new TypeError('Cannot Serialize a <input type="file">');
								case 'checkbox':
								case 'radio':
									if (!e.checked) continue;
							}
						case 'BUTTON':
						case 'TEXTAREA':
							add(e.name, e.value);
						break;
						case 'SELECT':
							o = e.options[e.selectedIndex];
							add(e.name, o.value || _.node.text(o));
					}
				}
				return r;
			}

		}, // _.form

		log : function(m, t) { t && msgLog[t] && msgLog[t](m); },

		make : function(s, a, e) {
			s = s.splitSelector();
			e = _d.createElement(s.tag);
			s.classes && (e.className = s.classes);
			s.id && (e.id = s.id);
			if (a) for (var i in a) {
				if (nodePlaces.indexOf(i) >= 0) _.node.add(a[i], e, i);
				else if (i.substr(0, 2) == 'on') _.event.add(e, i.substr(2), a[i]);
				else switch (i) {
					case 'content':
						_.node.add(e, a[i]);
						break;
					case 'style':
						for (var j in a[i]) e[i][j] = a[i][j];
						break;
					case 'type':
						// legacy IE can't handle setting type on input directly
						e.setAttribute(a[i], e, i);
						break;
					default:
						e[i] = a[i];
				}
			}
			return e;
		}, // _.make

		node : {

			add : function(e, c, p) {
				if (p) p = p.toLowerCase();
				if ('object' != typeof c) c = _d.createTextNode(c);
				switch (p) {
					case 'first' : e.insertBefore(c, e.firstChild); break;
					case 'before': e.parentNode.insertBefore(c, e); break;
					case 'after' : e.parentNode.insertBefore(c, e.nextSibling); break;
					case 'replace' : e.parentNode.replaceChild(c, e); break;
					default : e.appendChild(c);
				}
			},

			addSelectButton : function(e, t, n, p, b) {
				b = _.make('button.selectContents', {
					content : t || 'select',
					onclick : _.nodeSelect
				});
				_.data.set(b, d_sel, e);
				console.log(b);
				_.node.add(n || e, b, p || 'before');
			},

			countAll : function(e, m) {
				return nCountBy(e, m, 'eachAll');
			},

			countChildren : function(e, m) {
				return nCountBy(e, m, 'eachChild');
			},

			eachAll : function(e, c, m, z) {
				if (z = e.firstChild) do {
					if (
						(_.node.mask(z, m) && (c(z) === false)) ||
						(z.firstChild && (_.node.eachAll(z, c, m) === false))
					) return false;
				} while (z = z.nextSibling);
				return true;
			},

			eachChild : function(e, c, m, z) {
				if (z = e.firstChild) do {
					if (_.node.mask(z, m) && (c(z) === false)) return false;
				} while (z = z.nextSibling);
				return true;
			},

			first : function(e, m) {
				return _.node.walk(e, m, 'firstChild', 'nextSibling');
			},

			flush : function(e) {
				while (e.firstChild) e.removeChild(e.firstChild);
			},

			last : function(e, m) {
				return _.node.walk(e, m, 'lastChild', 'previousSibling');
			},

			mask : function(e, m) {
				if (isNaN(m = m || 1)) return (e.nodeType == 1) && (e.tagName == m.toUpperCase());
				return (1 << (e.nodeType == 0 ? 1 : e.nodeType - 1)) & (m > 0);
			},

			MASK : {
				ELEMENT    : 1,
				TEXT       : 4,
				PROCESSING : 64,
				COMMENT    : 128,
				DOCUMENT   : 256,
				DOCTYPE    : 512,
				FRAGMENT   : 1024,
			},

			next : function(e, m) {
				return _.node.walk(e, m, 'nextSibling', 'nextSibling');
			},

			nextRemove : function(e, m, n) {
				n = _.node.next(e, m);
				_.node.remove(e);
				return n;
			},

			prev : function(e, m) {
				return _.node.walk(e, m, 'previousSibling', 'previousSibling');
			},

			prevRemove : function(e, m, n) {
				n = _.node.prev(e, m);
				_.node.remove(e);
				return n;
			},

			remove : function(e) {
				e.parentNode.removeChild(e);
			},

			replace : function(e, n) {
				_.node.flush(e);
				_.node.add(e, n);
			},

			swap : function(e, n) {
				e.parentNode.replaceChild(e, typeof n == 'object' ? n : _d.createTextNode(n));
			},

			text : function(e) {
				return e ? e.innerText || e.textContent : false;
			},

			walk : function(e, m, f, n, z) {
				if (z = e[f]) do {
					if (_.node.mask(z, m)) return z;
				} while (z = z[n]);
				return false;
			}

		}, // _.node

		load : {

			css : function(h, m) {
				return m ? ( m = m.toLowerCase(), "all" == m && _.log(
					'media="all" is NOT recommended - ' + h, "warn"
				)) : _.log(
					'no media type declared, defaulting to "screen,projection,tv"', "warn"
				), _.make("link", {
					rel : "stylesheet",
					href : h,
					media : m || "screen,projection,tv",
					last : _d.head
				}
			)},

			script : function(s, a) {
				(a || (a = {})).src = s;
				a.last = _d.body;
				return _.make('script', a);
			}

		}, // _.load

		scroll : {

			maxX : function() {
				return _d.body.scrollWidth - _d.documentElement.clientWidth;
			},

			maxY : function() {
				return _d.body.scrollHeight - _d.documentElement.clientHeight;
			},

			x : function() {
				return _w.scrollX || _w.pageXOffset || _d.body.scrollLeft;
			},

			y : function() {
				return _w.scrollY || _w.pageYOffset || _d.body.scrollTop;
			}

		}, // _.scroll

		string : {

			normalize : function(s, t) {
				s = (
					typeof s == 'undefined' || (!s && s !== 0)
				) ? '' : String(s).trim();
				return t ? s.tolowercase() : s;
			}

		}, // _.string

		throw : {

			isNaN : function(e) {
				_.throw.isNull(e);
				if (e != e) throw new RangeError('value must be a number');
			},

			nonElement : function(e) {
				_.throw.isNull(e);
				if (e.nodeType !== 1) throw new TypeError(e + ' is not a DOM Element');
			},

			nonInstance : function(e, t) {
				_.throw.isNull(e);
				if (!e instanceof i) throw new TypeError(e + ' is not an instance of ' + i);
			},

			nonTag : function(e, t) {
				_.throw.isNull(e);
				if (
					1 == !e.nodeType || e.tagName != t.toUpperCase()
				) throw new TypeError(e + ' is not a <' + t + '>');
			},

			nonType : function(e, t) {
				_.throw.isNull(e);
				if (typeof e !== t) throw new TypeError(e + ' is not type "' + t + '"');
			},

			isNull : function(e) {
				if (e == null || typeof e == 'undefined') throw new TypeError(
					'Variable Null or Undefined'
				);
			},

			range : function(v, l, h) {
				_.throw.isNaN(v);
				if (v == Infinity) throw new RangeError(
					'value must be less than Inifinty'
				);
				if (!isNaN(l) && v < l) throw new RangeError(
					'number must be greater than or equal to ' + l
				);
				if (!isNaN(h) && v > h) throw new RangeError(
					'number must be less than or equal to ', + h
				);
			}

		}, // _.throw

		uSort : {

			element : function(e, c) {
				tList1 = [];
				switch (e.tagName) {
					case 'TBODY' :
						_.node.eachChild(e, uSortTBODYRow, 'TR');
						break;
					case 'UL':
					case 'OL':
						_.node.eachChild(e, uSortLi, 'LI');
						break;
					default: throw new TypeError(e + ' is not a TBODY, UL, or OL');
				}
				_.data.set(e, d_sort, true);
				tList1.sort(c);
				_.node.flush(e);
				for (var i = 0, j; j = tList1[i]; i++) e.appendChild(j.tag);
				tList1 = [];
			},

			restore : function(e) {
				switch (e.tagName) {
					case 'TBODY':
					case 'UL':
					case 'OL':
						if (_.data.get(e, d_sort)) _.uSort.element(e, originalSort);
					break;
					default: throw new TypeError(e + ' is not a TBODY, UL, or OL');
				}
			}

		} // _.uSort

	};

	// polyfills

	ptAdd(Array, {

		callbackAnd : function(e, c) {
			for (var i = 0, l = this.length; i < l; i++)
				if (!c(e, this[i])) return false;
			return true;
		},

		callbackAndAll : function(e, c) {
			for (var i = 0, l = this.length, r = false; i < l; i++)
				r = c(e, this[i]) && r;
			return r;
		},

		callbackOr : function(e, c) {
			for (var i = 0, l = this.length, r = false ; i < l; i++)
				r = c(e, this[i]) || r;
			return r;
		},

		every : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (!c.call(a, this[i], i, this)) return false;
			return true;
		},

		fill : function(v, s, e) {
			_.throw.isNull(this);
			if ('undefined' == typeof s) s = 0;
				else if (s < 0) s += this.length;
			if ('undefined' == typeof e) e = this.length;
			for (var i = s; i < e; i++) this[i] = v;
			return this;
		},

		filter : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var r = [], i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) r.push(this[i]);
			return r;
		},

		find : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return this[i];
		},

		findIndex : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return i;
		},

		forEach : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				c.call(a, this[i], i, this);
		},

		includes : function(s, i) {
			_.throw.isNull(this);
			if (this.length == 0) return false;
			if (typeof i == "undefined" || (i < 0 && (i += this.length) < 0)) i = 0;
			var t = s != s;
			for (var j = this.length; i < j; i++)
				if (s == this[i] || (t && this[i] != this[i])) return true;
			return false;
		},

		indexOf : function(s, i) {
			_.throw.isNull(this);
			if (this.length == 0) return false;
			if (typeof i == "undefined" || (i < 0 && (i += this.length) < 0)) i = 0;
			for (var j = this.length; i < j; i++) if (this[i] == s) return i;
			return -1;
		},

		isArray : function(a) {
			return Object.prototype.toString.call(a) === '[object Array]';
		},

		lastIndexOf : function(s, i) {
			_.throw.isNull(this);
			if (this.length == 0) return false;
			if (
				typeof i == "undefined" || (i < 0 && (i += this.length) < 0)
			) i = this.length;
			while (i > 0) if (this[--i] == s) return i;
			return -1;
		},

		map : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var r = [], i = 0, j = this.length; i < j; i++)
				r.push(c.call(a, this[i], i, this));
			return r;
		},

		reduce : function(c, v) {
			_.throw.nonType(c, 'function');
			var i = 0, j = this.length;
			if (typeof v == 'undefined') {
				if (!j) throw new TypeError(
					'Reduce of empty array with no initial value'
				);
				if (j == 1) return this[0];
				v = this[i];
				i++;
			}
			while (i < j) v = c(v, this[i], i++, this);
			return v;
		},

		reduceRight : function(c, v) {
			_.throw.nonType(c, 'function');
			var i = this.length;
			if (typeof v == 'undefined') {
				if (!i) throw new TypeError(
					'Reduce of empty array with no initial value'
				);
				if (i == 1) return this[0];
				v = this[--i];
			}
			while (i > 0) v = c(v, this[--i], i, this);
			return v;
		},

		some : function(c, a) {
			_.throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return true;
			return false;
		}

	});

	// you can't polyfill 'of' from prototype :/

	if (!Array.of) Array.of = function() {
		_.throw.isNull(this);
		return Array.prototype.slice.call(arguments);
	};

	ptAdd(String, {

		jsToCssName : function() {
			_.throw.isNull(this);
			var
				v = this.stripCamel(),
				f = this.indexOf('-');
			return ((
				(f > 0) && (f = v.substr(0,f)) &&
				(browserPrefixes.indexOf(f) !== -1)
			) ? '-' : '') + this;
		},

		pad : function(len, ch, i) {
			_.throw.isNaN(len);
			if ((i = Math.abs(len) - this.length) <= 0) return this;
			ch = (!ch && ch !== 0) ? ' ' : String(ch).charAt(0);
			return len < 0 ? ch.repeat(i) + this : this + ch.repeat(i);
		},

		repeat : function(c) {
			_.throw.isNull(this);
			_.throw.range(c = c || 0, 0, Math.floor(0x10000000 / this.length));
			return Array(Math.floor(c) + 1).join(this);
		},

		splitSelector : function() {
			_.throw.isNull(this);
			var
				r = { tag : 'div', id : false, classes : false},
				s = this, t;
			if ((t = s.indexOf('.')) >= 0) {
				r.classes = s.substr(t + 1).replace('.', ' ');
				s = (t > 0) ? s.substr(0, t) : '';
			}
			if ((t = s.indexOf('#')) >= 0) {
				r.id = s.substr(t + 1);
				s = (t > 0) ? s.substr(0, t) : '';
			}
			if (s.length > 0) r.tag = s;
			return r;
		},

		strFrom : function(c, l) {
			return (l = l ? this.lastIndexOf(c) : this.indexOf(c)) == -1 ? false : this.substr(l + 1);
		},

		stripCamel : function(d) {
			return _.throw.isNull(this), this.replace(stripCamelRegex, function(m) {
				return (d || '-') + m.toLowerCase();
			});
		},

		toCamel : function(d) {
			return _.throw.isNull(this), this.replace(toCamelRegex, function(m, m2, i) {
				return (i === 0 ? m : m.toUpperCase()).replace(d || '-','');
			});
		},

		trim : function() {
			return _.throw.isNull(this), this.replace(trimRegex, '');
		}

	});

	if (!_w.addEventListener) _.event.add = function(e, v, c) { new EventIE(e, v, c); };

	if (_d.selection) _.nodeSelect = function(e, r) {
		r = _d.body.createTextRange();
		r.moveToElementText(_.data.get(e.currentTarget, d_sel));
		r.select();
	}; else if (_w.getSelection) _.nodeSelect = function(e, r, s) {
		s = _w.getSelection();
		r = _d.createRange();
		r.selectNodeContents(_.data.get(e.currentTarget, d_sel));
		s.removeAllRanges();
		s.addRange(r);
	}; else _.nodeSelect = _.node.addSelectButton = function() {
		_.log('This browser does not support JavaScript selection of content', 'warn');
	};

	if (document.querySelectorAll) {
		_.query = function(e, q) { return e.querySelector(q); };
		_.query.all = function(e, q) {
			q = e.querySelectorAll(q);
			for (var r = [], i = 0, j; j = q[i]; i++) r.push(j);
			return r;
		};
	} else {
		var y = _d.createStyleSheet();
		_.query = function(e, s, r) {
			r = _.query.all(e, s, 1);
			return (r && r.length > 0) ? r[0] : null;
		};
		_.query.all = function(t, s, l, r) {
			l = l || 32767;
			r = [];
			y.addRule(s, 'fu:bar');
			function p(e) {
				if ((l > 0) && (e.currentStyle.fu === 'bar')) r.push(e);
				return --l > 0;
			}
			_.node.eachAll(t, p);
			y.removeRule();
			return r;
		};
	}

	window.JSON || (window.JSON = {
		parse : function(s) { return eval('(' + s + ')'); },
		stringify : function(s, r) {
			if (null == s) return s;
			switch (typeof s) {
				case 'number': return isFinite(s) ? s.toString() : 'null';
				case 'boolean': return s.toString();
				case 'object':
					if (typeof s.toJSON === 'function') return JSON.stringify(s.toJSON());
					r = [];
					if (Array.prototype.isArray.call(s)) {
						s.forEach(function(e) { r.push(JSON.stringify(e)); });
						return '[' + r.join() + ']';
					}
					if (_.toString(s) === '[object Object]') {
						for (var i in s) r.push(JSON.stringify(i) + ':' + JSON.stringify(s[i]));
						return '{' + r.join() + '}';
					}
			}
			return '"' + s.toString().replace(escRegex, escFunc) + '"';
		}
	});

	var p =
		(false == 'performance' in _w) ?
		(_w.performance = {}) :
		_w.performance;
	if (false == 'now' in p) {
		var nowOffset = (
			p.timing && p.timing.navigationStart
		) ? p.timing.navigationStart : new Date().getTime();
		p.now = function() { return new Date().getTime() - nowOffset; };
	}

	// requestAnimation Polyfill based on code by Erik Mller
	// I'd link but the bloody page is gone! Thanks "My Opera"

	if (!browserFix(_w, raf)) _w[raf] = function(c) {
		var
			n = p.now(),
			w = Math.max(0, 16.666667 - n - lastAnimTime);
		lastAnimTime = n + w;
		return setTimeout( function() { c(lastAnimTime); }, w);
	};

	if (
		!browserFix(_w, caf) &&
		!browserFix(_w, caf, 'CancelRequestAnimationFrame')
	) _w[caf] = clearTimeout;

	_.class.add(_d.body, 'elementals');

})();